#include "Clustering.h"
#include <limits>
#include <boost/foreach.hpp>

namespace AG
{
	namespace Clustering{

		void Clustering::qt_clustering(VectorSpace & vs, unsigned int max_diameter, unsigned int max_iterations)
		{
			Clusters clusters(vs.size(), std::numeric_limits<index>::max());  // assign all the vectors to no cluster
			double distance;

			index docId_i = 0;
			BOOST_FOREACH(Vect d_i, vs)         // foreach document
			{
				clusters[docId_i] = docId_i;    // assigned docID to cluster with ID=docId;	

				index docId_j = docId_i+1;  // consider all the remaining points
				
	            // find documents with minum distance, among all the following vectors
				while (docId_j < vs.size())
				{
					if (clusters[docId_j] == std::numeric_limits<index>::max())
					{ 					
						distance = norm_2 (d_i- vs[docId_j]);  
						std::cout << "docId_i:" << docId_i << " docId_j:" << docId_j << " distance " << distance << std::endl;
						if (distance < max_diameter)
						{
							clusters[docId_j] = docId_i; 
							std::cout << "   Assigning " << docId_j << " to cluster" << docId_i << std::endl;
						}
					}
					docId_j++;
				}
				docId_i++;
			} // foreach document
		};
	}; /* Clustering */
};
